<!--
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
-->

<link rel="import" href="../polymer/polymer.html">
<link rel="import" href="../paper-input/paper-input-behavior.html">
<link rel="import" href="../paper-input/paper-input-container.html">
<link rel="import" href="../paper-input/paper-input-error.html">
<link rel="import" href="../iron-input/iron-input.html">
<link rel="import" href="../iron-form-element-behavior/iron-form-element-behavior.html">
<link rel="import" href="date-validator.html">

<!--
Simple inputs to validate date instead of using a calendar. 2 formats available: YYYY/MM/DD and DD/MM/YYYY.
  
  <date-input date-format="YYYY/MM/DD" value="{{value}}"></date-input>

You can add constraints like max-date and min-date.
  
  <date-input date-format="YYYY/MM/DD" value="{{value}}" max-date="{{maxDate}}" min-date="{{minDate}}"></date-input>

IMPORTANT: takes a local date as input and send back a local date. Make utc convertion in your elements.

@demo demo/index.html
-->

<dom-module id="date-input">
  <template>
    <style>
      :host {
        display: inline-block;
      }
      input[is="iron-input"] {
        font: inherit;
        outline: none;
        box-shadow: none;
        border: none;
        width: auto;
        text-align: center;
      }
      .container {
        @apply(--layout-horizontal);
      }
    </style>
    
    <paper-input-container 
      id="container"
      disabled$="[[disabled]]"
      invalid="[[invalid]]"
      always-float-label>
      
      <label hidden$="[[!label]]">[[label]]</label>

      <date-validator></date-validator>
    
      <input 
        is="iron-input"
        type="text"
        id="dateInputOne"
        bind-value="{{_input1}}"
        allowed-pattern="[0-9]+"
        required>
      <span class="separator">/</span>

      <input 
        is="iron-input"
        type="text"
        id="dateInputTwo"
        bind-value="{{_input2}}"
        allowed-pattern="[0-9]+" 
        required
        >
      <span class="separator">/</span>

      <input 
        is="iron-input"
        type="text"
        id="dateInputThree"
        bind-value="{{_input3}}"
        allowed-pattern="[0-9]+"
        required >   
      
      <template is="dom-if" if="[[errorMessage]]">
        <paper-input-error id="error">[[errorMessage]]</paper-input-error>
      </template>

      </paper-input-container>

  </template>

  <script>
    (function() {
           
      Polymer({
        is: 'date-input',
        
        properties: {
          /**
           * Input label
           */
          label: {
            type: String
          },
          value: {
            notify: true,
            type: String
          },
          /**
           * Max date contraint
           * @type {Date}
           */
          maxDate: {
            type: Date
          },
          /**
           * Min date constraint
           * @type {Date}
           */
          minDate: {
            type: Date
          },
          /**
           * Input format available: YYYY/MM/DD or DD/MM/YYYY
           * @type {String}
           */
          format: {
            type: String,
            value: 'YYYY/MM/DD'
          },
          /**
           * Custom validator used to validate date
           * @type {String}
           */
          validator: {
            type: String,
            value: 'date-validator'
          },
          /**
           * Store DOM input element
           * @type {Array}
           */
          _elements: {
            type: Array,
            value: []
          },
          _input1: {
            type: String
          },
          _input2: {
            type: String
          },
          _input3: {
            type: String
          }
        },

        behaviors: [
          Polymer.IronValidatableBehavior,
          Polymer.IronFormElementBehavior
        ],

        observers: [
          '_computeDate(_input1, _input2, _input3)'
        ],

        attached: function() {
          this.dateValidator = new Polymer.IronMeta({type: 'validator'}).byKey(this.validator);
          var dateParts = this._extractDateParts(this.value);
          this._getDOMInputElements();
          this._defineInputsPropertiesAndValue(dateParts, this.format);
          this._setPaperInputContainerState(this.value, true);
          this._enableDateConstraints();
        },

        /** 
         * set flag for optional constraints on date like:
         *  - max-date
         *  - min-date
         */
        _enableDateConstraints: function() {
          this.hasMaxDate = typeof this.maxDate !== 'undefined' ? true : false;
          this.hasMinDate = typeof this.minDate !== 'undefined' ? true : false;
        },

        _extractDateParts: function(date) {
          var year, month, day;

          if(!this._isValidDate(date)) {
            console.warn('date is not good: ' + date + ' - can\'t populate inputs');
          } else {
            year = "" + date.getFullYear();
            month = ("0" + (date.getMonth() + 1)).slice(-2);
            day = ("0" + date.getDate()).slice(-2);
          }

          return [year, month, day];
        }, 

        _isValidDate: function(date) {
          return Object.prototype.toString.call(date) === "[object Date]" && !isNaN(date.getTime());
        },

        _getDOMInputElements: function() {
          this._elements = Polymer.dom(this.$$('#container')).querySelectorAll('input');
        },

        _defineInputsPropertiesAndValue: function(dateParts, dateFormat) {
          var dateFormatList = this._splitDateFormat(dateFormat);
          this._defineContraintsAndValuesOnInputs(dateParts, dateFormatList);
        },

        _splitDateFormat: function(dateFormat) {
          if(this._isValidDateFormat(dateFormat)) {
            return dateFormat.split('/');
          }

          throw new Error('invalid format: ' + dateFormat + '(valid format are "YYYY/MM/DD" or "DD/MM/YYYY"');
        },

        _isValidDateFormat: function(dateFormat) {
          return dateFormat.indexOf('YYYY/MM/DD') > -1 || dateFormat.indexOf('DD/MM/YYYY') > -1;
        },

        _defineContraintsAndValuesOnInputs: function(dateParts, dateFormatList) {
          for(var i = 0; i < dateFormatList.length; i++) {
            var selector = this._elements[i];
            this._defineContraintsAndValueOnInput(dateFormatList[i], selector, dateParts[i]);
          }
        },

        _defineContraintsAndValueOnInput: function(format, selector, dateValue) {

          switch(format) {
            case 'YYYY':
              this._setInputProperties(selector, 'YYYY', 4, 4);
              break;
            case 'MM':
              this._setInputProperties(selector, 'MM', 2, 2);
              break;
            case 'DD':
              this._setInputProperties(selector, 'DD', 2, 2);
              break;
            default:
              throw new Error('format not supported: ' + format);
          }

          if(dateValue) {
            this._setInputValue(selector, dateValue);
          }
        },

        _setInputValue: function(selector, value) {
          selector.value = value;
        },

        _setInputProperties: function (selector, dateFormat, minlength, maxlength) {
          selector.setAttribute('data-date', dateFormat);
          selector.setAttribute('minlength', minlength);
          selector.setAttribute('maxlength', maxlength);
          selector.setAttribute('placeholder', dateFormat);
        },

        /**
         * Called when inputs change
         */
        _computeDate: function(_input1, _input2, _input3) {
          var date = this._extractInputsValueBeforeValidate();

          if (!date.day && !date.month && !date.year) {
            this._setSelectedDate(null, false);
          } else {
            var selectedDate = date.year + '/' + date.month + '/' + date.day;  
            var isValidDate = this._mkValidation(selectedDate);              
            this._setPaperInputContainerState(selectedDate, isValidDate);
            this._setSelectedDate(selectedDate, isValidDate);
          }      
        },

        /**
         * Split string and return an object
         * @return {Object}
         */
        _extractInputsValueBeforeValidate: function() {
          var o = {};

          if (this._elements) {
            for(var i = 0; i < this._elements.length; i++) {
              var format = this._elements[i].dataset.date;
              var value = this._elements[i].value;
              o[this._mkKey(format)] = value;
            }
          }
          
          return o;
        },

        _mkKey: function(format) {
          
          switch(format) {
            case 'DD':
              key = 'day';
              break;
            case 'MM':
              key = 'month';
              break;
            case 'YYYY':
              key = 'year';
              break;
            default:
              throw new Error('format not supported: ', format);
          }

          return key;
        },

        _setSelectedDate: function(date, valid) {
          this.value = valid ? new Date(date) : null;
        },

        /**
         * @param  {String} selected date
         * @return {Boolean} date valid or not
         */
        _mkValidation: function(date) {
          var isValid = false;
          if(this.dateValidator.validate(date)) {
            isValid = this._extraValidation(date);
          }

          return isValid;
        },

        _extraValidation: function(date) {
          var selectedDate = new Date(date).setHours(0,0,0,0);
          isValidMaxDate = this.hasMaxDate ? (selectedDate <= this.maxDate.setHours(0,0,0,0)) : true;
          isValidMinDate = this.hasMinDate ? (selectedDate >= this.minDate.setHours(0,0,0,0)) : true;
          
          return isValidMaxDate && isValidMinDate;
        },

        /**
         * set paper-input-container state
         * 
         * @param {String} selected date
         * @param {Boolean} is valid date
         */
        _setPaperInputContainerState: function(date, valid) {
          this.$.container.invalid = !valid;

          this.$.container.updateAddons({
            value: new Date(date),
            invalid: !valid
          });
        }
      });
})();
</script>
</dom-module>